diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant2D.java
index 7a2ee024a..19e33b976 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant2D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant2D.java
@@ -3,15 +3,24 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise2D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 import java.util.Arrays;
 
 public class Constant2D
     implements Noise2D {
+    private final @NotNull Vector2dc range;
     protected final double value;
 
     public Constant2D(final double value) {
         this.value = value;
+        this.range = new Vector2d(value);
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return this.range;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant3D.java
index 5f821e403..bace46bf3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant3D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Constant3D.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise3D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2dc;
 
 import java.util.Arrays;
 
@@ -13,6 +14,11 @@ public class Constant3D
         super(value);
     }
 
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return this.getRange2D();
+    }
+
     @Override
     public double getValue(final double x, final double y, final double z) {
         return this.value;
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss2D.java
index 170772571..6917bced2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss2D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss2D.java
@@ -3,15 +3,25 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise2D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 public class Emboss2D<T extends Noise2D>
     implements Noise2D {
+    private final @NotNull Vector2d range = new Vector2d();
     protected final @NotNull T noise;
 
     public Emboss2D(final @NotNull T noise) {
         this.noise = noise;
     }
 
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        final @NotNull Vector2dc noiseRange = this.noise.getRange2D();
+        this.range.set(noiseRange.x() - noiseRange.y(), noiseRange.y() - noiseRange.x());
+        return this.range;
+    }
+
     @Override
     public double getValue(final double x, final double z) {
         return this.noise.getValue(x, z) - this.noise.getValue(x + 1.0, z + 1.0);
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss3D.java
index 196fc3511..4bff1c444 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss3D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Emboss3D.java
@@ -3,14 +3,25 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise3D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 public class Emboss3D<T extends Noise3D>
     extends Emboss2D<T>
     implements Noise3D {
+    private final @NotNull Vector2d range = new Vector2d();
+
     public Emboss3D(@NotNull final T noise) {
         super(noise);
     }
 
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        final @NotNull Vector2dc noiseRange = this.noise.getRange3D();
+        this.range.set(noiseRange.x() - noiseRange.y(), noiseRange.y() - noiseRange.x());
+        return this.range;
+    }
+
     @Override
     public double getValue(final double x, final double y, final double z) {
         return this.noise.getValue(x, y, z) - this.noise.getValue(x + 1.0, y + 1.0, z + 1.0);
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Normalize2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Normalize2D.java
new file mode 100644
index 000000000..138e05dde
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Normalize2D.java
@@ -0,0 +1,56 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise2D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
+
+public class Normalize2D<T extends Noise2D>
+    implements Noise2D {
+    private static final @NotNull Vector2dc RANGE = new Vector2d(0.0, 1.0);
+
+    protected final @NotNull T noise;
+
+    public Normalize2D(final @NotNull T noise) {
+        this.noise = noise;
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return RANGE;
+    }
+
+    @Override
+    public double getValue(final double x, final double z) {
+        final @NotNull Vector2dc range = this.noise.getRange2D();
+        final double r = range.y() - range.x();
+        final double v = this.noise.getValue(x, z);
+        final double vo = v - range.x();
+        return vo / r;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
+        if (out == null || out.length < xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
+
+        final @NotNull Vector2dc range = this.noise.getRange2D();
+        final double r = range.y() - range.x();
+
+        final double @NotNull [] temp = this.noise.addRegion(null, x, z, xSize, zSize, xScale, zScale, amplitude);
+        for (int i = 0; i < out.length; i++) {
+            temp[i] = (temp[i] - range.x()) / r;
+            out[i] += temp[i];
+        }
+
+        return out;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Normalize3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Normalize3D.java
new file mode 100644
index 000000000..e3bfde927
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Normalize3D.java
@@ -0,0 +1,52 @@
+package net.minecraft.core.world.noise.operator;
+
+import net.minecraft.core.world.noise.Noise3D;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2dc;
+
+public class Normalize3D<T extends Noise3D>
+    extends Normalize2D<T>
+    implements Noise3D {
+    public Normalize3D(final @NotNull T noise) {
+        super(noise);
+    }
+
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return this.getRange2D();
+    }
+
+    @Override
+    public double getValue(final double x, final double y, final double z) {
+        final @NotNull Vector2dc range = this.noise.getRange2D();
+        final double r = range.y() - range.x();
+        final double v = this.noise.getValue(x, y, z);
+        final double vo = v - range.x();
+        return vo / r;
+    }
+
+    @Override
+    public double @NotNull [] addRegion(
+        double @Nullable [] out,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale,
+        final double amplitude
+    ) {
+        if (out == null || out.length < xSize * zSize) {
+            out = new double[xSize * zSize];
+        }
+
+        final @NotNull Vector2dc range = this.noise.getRange2D();
+        final double r = range.y() - range.x();
+
+        final double @NotNull [] temp = this.noise.addRegion(null, x, y, z, xSize, ySize, zSize, xScale, yScale, zScale, amplitude);
+        for (int i = 0; i < out.length; i++) {
+            temp[i] = (temp[i] - range.x()) / r;
+            out[i] += temp[i];
+        }
+
+        return out;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate2D.java
index c0cb028a1..c9bac69cf 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate2D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate2D.java
@@ -3,6 +3,8 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise2D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2d;
+import org.joml.Vector2dc;
 
 public class Rotate2D<T extends Noise2D>
     implements Noise2D {
@@ -17,6 +19,11 @@ public class Rotate2D<T extends Noise2D>
         this.cos = Math.cos(yRot);
     }
 
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return this.noise.getRange2D();
+    }
+
     @Override
     public double getValue(final double x, final double z) {
         return this.noise.getValue(x * this.cos + z * this.sin, z * this.cos - x * this.sin);
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate3D.java
index 1ff820244..95c8e8074 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate3D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Rotate3D.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise3D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2dc;
 
 public class Rotate3D<T extends Noise3D>
     extends Rotate2D<T>
@@ -23,6 +24,11 @@ public class Rotate3D<T extends Noise3D>
         };
     }
 
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return this.noise.getRange3D();
+    }
+
     @Override
     public double getValue(final double x, final double y, final double z) {
         final double nx = this.rot[0][0] * x + this.rot[0][1] * y + this.rot[0][2] * z;
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale2D.java
index 2e504f3a4..2eae3a8d8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale2D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale2D.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise2D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2dc;
 
 public class Scale2D<T extends Noise2D>
     implements Noise2D {
@@ -16,6 +17,11 @@ public class Scale2D<T extends Noise2D>
         this.zScale = 1.0 / zScale;
     }
 
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return this.noise.getRange2D();
+    }
+
     @Override
     public double getValue(final double x, final double z) {
         return this.noise.getValue(x * this.xScale, z * this.zScale);
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale3D.java
index f578c5301..9e4a5c512 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale3D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Scale3D.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise3D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2dc;
 
 public class Scale3D<T extends Noise3D>
     extends Scale2D<T>
@@ -15,6 +16,11 @@ public class Scale3D<T extends Noise3D>
         this.yScale = yScale;
     }
 
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return this.noise.getRange3D();
+    }
+
     @Override
     public double getValue(final double x, final double y, final double z) {
         return this.noise.getValue(x * this.xScale, y * this.yScale, z * this.zScale);
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp2D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp2D.java
index 46e1b9380..1892f01ee 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp2D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp2D.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise2D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2dc;
 
 public class Warp2D<A extends Noise2D, B extends Noise2D, C extends Noise2D>
     implements Noise2D {
@@ -16,6 +17,11 @@ public class Warp2D<A extends Noise2D, B extends Noise2D, C extends Noise2D>
         this.warpZ = warpZ;
     }
 
+    @Override
+    public @NotNull Vector2dc getRange2D() {
+        return this.base.getRange2D();
+    }
+
     @Override
     public double getValue(final double x, final double z) {
         return this.base.getValue(
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp3D.java b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp3D.java
index f2c8dc289..da3d1ee88 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp3D.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/operator/Warp3D.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.noise.operator;
 import net.minecraft.core.world.noise.Noise3D;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector2dc;
 
 public class Warp3D<A extends Noise3D, B extends Noise3D, C extends Noise3D, D extends Noise3D>
     extends Warp2D<A, B, D>
@@ -15,6 +16,11 @@ public class Warp3D<A extends Noise3D, B extends Noise3D, C extends Noise3D, D e
         this.warpY = warpY;
     }
 
+    @Override
+    public @NotNull Vector2dc getRange3D() {
+        return this.base.getRange3D();
+    }
+
     @Override
     public double getValue(final double x, final double y, final double z) {
         return this.base.getValue(
diff --git a/game/core/src/test/java/TestNoise.java b/game/core/src/test/java/TestNoise.java
index 28711ac46..16f90ba68 100644
--- a/game/core/src/test/java/TestNoise.java
+++ b/game/core/src/test/java/TestNoise.java
@@ -1,8 +1,10 @@
 import net.minecraft.core.world.noise.*;
+import net.minecraft.core.world.noise.operator.Normalize2D;
 import org.jetbrains.annotations.NotNull;
 import org.junit.jupiter.api.Assertions;
 import org.junit.jupiter.api.Test;
 
+import java.util.Arrays;
 import java.util.Random;
 
 public class TestNoise {
@@ -67,4 +69,23 @@ public class TestNoise {
         noise.getRegion(out, 0.0, 0.0, 4, 4, 512.0, 512.0);
         Assertions.assertArrayEquals(expected, out);
     }
+
+    @Test
+    public void test() {
+        double min = Double.POSITIVE_INFINITY, max = Double.NEGATIVE_INFINITY;
+
+        for (int i = 0; i < 1000; i++) {
+        final var noise = new Normalize2D<>(new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(0, 2)));
+//            final var noise = new Normalize2D<>(new WorleyNoise(new Random(i)));
+            final @NotNull Random random = new Random(i);
+
+            for (int x = 0; x < 1000; x++) {
+                final double d = noise.getValue(-5000 + random.nextFloat() * 10000, -5000 + random.nextFloat() * 10000);
+                min = Math.min(min, d);
+                max = Math.max(max, d);
+            }
+        }
+
+        System.out.println("min: " + min + " max: " + max);
+    }
 }
